#include "define.h"
#include <mysql.h>
#include "item.h"
#include "npc.h"
#include "skill.h"
#include "map.h"

#define CIRQUE_SIZE 1024

class Databases
{

public:
	Databases(void);
	~Databases(void){}

	//if valid.. user data load
	BOOL UserAuth(char * userid, char * passwd, WORD passlen,Ptype_session c);
	char * db_ret_tcpip(int idx);
	short db_ret_tcpport(int idx);
	type_sockadr * db_ret_udpsock(int idx);
	int db_ret_udpLen(int idx);
	BOOL LevelUpCheck(Ptype_session c);		
	BOOL SaveAll(Ptype_session c);

private:
	BOOL InitMap(void);
	BOOL InitDatabase(void);
	void LoadItemList(void);
	void LoadExpList(void);
	void LoadNpcList(void);
	void LoadSkillList(void);
	BOOL LoadSvrList(void);

	BOOL EnqueQry(char * qry);

	BYTE * ReturnTcpIp(int idx);
	WORD ReturnTcpPort(int idx);
	type_sockadr * ReturnUdpSock(int idx);
	DWORD ReturnUdpLen(int idx);

	BOOL ItemPick(Ptype_session c, WORD invidx);
	BOOL ItemDrop(Ptype_session c, WORD invidx);
	BOOL ItemBuy(Ptype_session c, WORD invidx);
	BOOL ItemSell(Ptype_session c, char * data);
	BOOL ItemTrade(Ptype_session c, Ptype_session Tgc, char * sChange, char * tChange);
	BOOL ItemWear(Ptype_session c, WORD invidx,BYTE eqidx);
	BOOL ItemPos(Ptype_session c,BYTE sidx,BYTE didx);
	BOOL ItemWarePos(Ptype_session c, WORD invidx,BYTE wareidx);
	BOOL SaveExpMoney(Ptype_session c);
	BOOL SetSkill(Ptype_session c, BYTE skidx);
	BOOL LevelUp(Ptype_session c);

public:
	Items	m_Item;		//item 
	Npcs	m_Npc;		//npc
	Skills	m_Skill;	//skill
	Maps	m_Map;		//map

	DWORD exp_list[MAXUSERLEVEL+1];//ol㏸`FbNz
	MYSQL * mydata;
	int cirQueLen,getPos,putPos,overPos;
	t_cir_queue DBcircQue[CIRQUE_SIZE];//zL[

	CRITICAL_SECTION d_cs;

private:

	struct svrLst
	{
		BYTE 			ip[4];//ip for tcp
		WORD			tport;//port for tcp
		type_sockadr	udpSvr;//udp socket struct
		DWORD			udpLen;//udp len
	}worldinfo[MX_SVR_NO];
};
