#pragma once
#include "define.h"
#ifndef OBJECTLIST_DEFINE
#include "ObjectList.h"
#endif

class Items
{

public:
	Items(void){
		int i,j;
		for(i=0;i<100;i++) item0[i].is_init=0;
		for(i=0;i<S_WIDTH;i++)
			for(j=0;j<S_WIDTH;j++)
				item_sect[i][j].objL=NULL;
		InitializeCriticalSection(&i_cs);
	};
	~Items(void){}

	BOOL InitItem(void);
	void * voidItemListGetFirst(type_objlist const * const * * save,unsigned short i, unsigned short j);
	void * voidItemListGetNext(type_objlist const * const * * save);
	void ItemLoad(char **dat);
	void Item3x3SecterInfo(Ptype_session c,PVOID param);
	WORD ItemGetRange(WORD itemNo);
	WORD ItemGetAttack(WORD itemNo);
	WORD ItemGetDefence(WORD itemNo);
	WORD ItemReturnDefaultCount(WORD idx);
	DWORD ReturnNullItemIndex();
	void ResetItemIndex(DWORD idx);
	void SetItemIndex(DWORD idx);
	type_itemLst_field * ItemAddSect(WORD Ax, WORD Ay, type_itemLst_field * fitem);
	void ItemBuy(Ptype_session c,PVOID param);
	void ItemSell(Ptype_session c,PVOID param);
	void ItemPick(Ptype_session c,PVOID param);
	BOOL ItemDrop(Ptype_session c,PVOID param);
	BOOL ItemPos(Ptype_session c,PVOID param);
	BOOL ItemWear(Ptype_session c,PVOID param);
	void ItemRecalStat(Ptype_session c);
	BOOL ItemTradeRequest(Ptype_session c,PVOID param);
	BOOL ItemTradeRequestOk(Ptype_session c,PVOID param);
	BOOL ItemTradeList(Ptype_session c,PVOID param);
	BOOL ItemTradeOk(Ptype_session c,PVOID param);
	BOOL ItemTradeCancel(Ptype_session c,PVOID param);
	void ItemWareInfo(Ptype_session c,PVOID param);
	void ItemWarePos(Ptype_session c,PVOID param);
	void ItemWareDepos(Ptype_session c,PVOID param);
	void ItemRmSect(type_itemLst_field * fitem);



public:
	CRITICAL_SECTION i_cs;

private:
	void ItemRemoveInfo(WORD x,WORD y,WORD idx,PVOID param);


private:
	type_itemArr 		item_map[M_SIZE_X][M_SIZE_X];//ACez.. ACeuĂ邩? n uĂ邩?`FbN..
	type_itemSect 		item_sect[S_WIDTH][S_WIDTH];//ACeZN^....
	type_itemIdx 		itemNo[_MAX_ITEM_IDX];//tB[hɂACez
	type_item 			item0[_MAX_DEFAULT_ITEM];//ʃACe
	ObjectList			m_obj;

};
