#include "define.h"
#include "network.h"

DWORD __stdcall ThreadItemSync(PVOID param);
DWORD __stdcall ThreadNpcSync(PVOID param);
DWORD __stdcall ThreadDataBase(PVOID param);
DWORD __stdcall ThreadSync(PVOID param);
DWORD __stdcall ThreadPacketReceiver(PVOID param);

int tUsercnt = 0;

int main(int argc, char* argv[])
{
	cNetwork	nc;
	DWORD		dwThreadId;
	WSADATA		wsaData;
	SOCKADDR_IN	ServerAddr;

	WSAStartup( MAKEWORD(2,2) , &wsaData ) ;
	nc.m_listenSocket = WSASocket(AF_INET,SOCK_STREAM,IPPROTO_TCP,NULL,NULL,WSA_FLAG_OVERLAPPED);
		
	ServerAddr.sin_family=AF_INET;
	ServerAddr.sin_port=htons(_G_TCP_PORT);
	ServerAddr.sin_addr.s_addr=htonl(INADDR_ANY);
	
	bind(nc.m_listenSocket,(SOCKADDR *)&ServerAddr,sizeof(SOCKADDR_IN) ) ;
	listen(nc.m_listenSocket,5) ;
	
	dwThreadId=1;
	HANDLE hThread1=CreateThread(NULL,0,ThreadPacketReceiver,&nc,0,&dwThreadId);
	CloseHandle(hThread1);

	dwThreadId=2;
	HANDLE hThread2=CreateThread(NULL,0,ThreadDataBase,&nc,0,&dwThreadId);
	CloseHandle(hThread2);

	Sleep(500);
	dwThreadId=3;
	HANDLE hThread3=CreateThread(NULL,0,ThreadSync,&nc,0,&dwThreadId);
	CloseHandle(hThread3);

	Sleep(500);
	dwThreadId=4;
	HANDLE hThread4=CreateThread(NULL,0,ThreadItemSync,&nc,0,&dwThreadId);
	CloseHandle(hThread4);

	Sleep(500);
	dwThreadId=5;
	HANDLE hThread5=CreateThread(NULL,0,ThreadNpcSync,&nc,0,&dwThreadId);
	CloseHandle(hThread5);


	while(TRUE){
		Sleep(1000000);
	}
	return 0;
}


DWORD __stdcall ThreadItemSync(PVOID param){

	int i,j,itm_cnt;
	type_objlist  const * const * tmp_objlist;
	void * ntmp_itm,* itm;
	type_itemLst_field * tmp_itm;
	
	cNetwork* pNc=(cNetwork*)param;

	while(1){
		itm_cnt=0;
		EnterCriticalSection(&pNc->m_database.m_Item.i_cs);
		for(i=0;i<S_WIDTH;i++){
			for(j=0;j<S_WIDTH;j++){
				for(itm=pNc->m_database.m_Item.voidItemListGetFirst(&tmp_objlist,i,j); itm; itm=ntmp_itm)
				{
					itm_cnt++;
					tmp_itm = (type_itemLst_field *)itm;
					ntmp_itm = pNc->m_database.m_Item.voidItemListGetNext(&tmp_objlist);

					if(tmp_itm->rmFcnt>30) pNc->m_database.m_Item.ItemRmSect(tmp_itm);
					else tmp_itm->rmFcnt+=1;

				}
			}
		}
		LeaveCriticalSection(&pNc->m_database.m_Item.i_cs);
		Sleep(1000);
	}//end while
}


DWORD __stdcall ThreadNpcSync(PVOID param){//syncronizer thread for npc

	long	start,stop,tmp;
	int 	i,j;
	Ptype_session tgChr;
	type_npc * tmpNpc;
	WORD Rest=0,torf=0,dist=0,rotate_time=GAME_FRAME*5;
	
	cNetwork* pNc=(cNetwork*)param;

	Sleep(2000);
	for(;;){
		start=GetTickCount();
//printf("NPC:%d\n",pNc->m_database.m_Npc.npc_cnt);
		EnterCriticalSection(&pNc->m_database.m_Npc.n_cs);
		for(i=0;i<pNc->m_database.m_Npc.npc_cnt; i++)//linked list syncronize
		{

			if(pNc->m_database.m_Npc.npcArray[i]==NULL) continue;
			if(pNc->m_database.m_Npc.npcArray[i]->div==1||pNc->m_database.m_Npc.npcArray[i]->div==0) continue;//npc
			if(pNc->m_database.m_Npc.npcArray[i]->status==S_DIE){//񂾏

				if(pNc->m_database.m_Npc.npcArray[i]->regen_F_cnt>REGEN){
					pNc->m_database.m_Npc.NpcRegen(i,param);//
					pNc->m_database.m_Npc.npcArray[i]->mvstatus = 0;
				}else pNc->m_database.m_Npc.npcArray[i]->regen_F_cnt++;
				continue;

			}else if(pNc->m_database.m_Npc.npcArray[i]->status==S_FIGHT){

				tgChr = (Ptype_session)pNc->m_database.m_Npc.npcArray[i]->targetChr;
				dist =pNc->m_database.m_Map.MapReturnDist(pNc->m_database.m_Npc.npcArray[i]->x,
						pNc->m_database.m_Npc.npcArray[i]->y,tgChr->Cx,tgChr->Cy);//npcƃLN^[Ԃ̋^[

				if(dist<0){
					pNc->m_database.m_Npc.npcArray[i]->targetChr =NULL;
					pNc->m_database.m_Npc.npcArray[i]->status=S_STAND;
					pNc->m_database.m_Npc.npcArray[i]->mvstatus = 0;
					continue;
				}

				if(pNc->m_database.m_Npc.npcArray[i]->tgLen>=dist){//Ōɂ邽ߑŌ. -->send list square
					if(pNc->m_database.m_Npc.npcArray[i]->heat_F_cnt>=_ONE_SEC){
						pNc->m_database.m_Npc.NpcAttackChr(tgChr,i,param);//attack
						pNc->m_database.m_Npc.npcArray[i]->move_F_cnt=0;
						pNc->m_database.m_Npc.npcArray[i]->heat_F_cnt=0;
						pNc->m_database.m_Npc.npcArray[i]->wait_F_cnt=0;
						pNc->m_database.m_Npc.npcArray[i]->mvstatus = 0;
					}else pNc->m_database.m_Npc.npcArray[i]->heat_F_cnt++;
				}else if(dist<_NPC_TGT_SIG){//ǌ͈͓ɂꍇ

					pNc->m_database.m_Npc.NpcMoveSet(i,param);
					continue;

				}else{//^[Qbg삩Ƃ..ǂ..
					pNc->m_database.m_Npc.npcArray[i]->status=S_STAND;
					pNc->m_database.m_Npc.npcArray[i]->mvstatus = 0;
					pNc->m_database.m_Npc.npcArray[i]->tgFlag= 0;
				}
				continue;

			}else{//U⎀񂾏Ԃł͂Ȃꍇ ? ʂ̏Ԃ̐lHm\...

				if(pNc->m_database.m_Npc.npcArray[i]->bat_type==T_ACTIVE){//U郂X^[̏ (Y΍sAȂ΂̂܂ܐlHm\)
					if((pNc->m_database.m_Npc.npcArray[i]->targetChr 
							= pNc->m_database.m_Map.MapReturnActiveTarget(pNc->m_database.m_Npc.npcArray[i]->x, 
												pNc->m_database.m_Npc.npcArray[i]->y,
												pNc->m_database.m_Npc.npcArray[i]->Sight))!=NULL){//߂Ƀ^[QbgƂ擪[hɓ...
						tgChr = (Ptype_session)pNc->m_database.m_Npc.npcArray[i]->targetChr;
						pNc->m_database.m_Npc.npcArray[i]->targetNO = tgChr->userNo;
						pNc->m_database.m_Npc.npcArray[i]->status = S_FIGHT;
						pNc->m_database.m_Npc.npcArray[i]->tgFlag= 1;
						continue;
					}
				}else if(pNc->m_database.m_Npc.npcArray[i]->bat_type==T_GROUP){//Wc^ npc(U Ȃ͂Ő킦΍sĂƂɐ키)
///////
					if((tmpNpc=pNc->m_database.m_Npc.NpcReturnFight(i,param))!=NULL){
						pNc->m_database.m_Npc.npcArray[i]->targetNO= tmpNpc->targetNO;
						pNc->m_database.m_Npc.npcArray[i]->targetChr= tmpNpc->targetChr;
						pNc->m_database.m_Npc.npcArray[i]->status = S_FIGHT;
						pNc->m_database.m_Npc.npcArray[i]->tgFlag= 1;
					}
				}

				if(pNc->m_database.m_Npc.npcArray[i]->status==S_MOVE){
					if(pNc->m_database.m_Npc.npcArray[i]->dx!=pNc->m_database.m_Npc.npcArray[i]->x
						||pNc->m_database.m_Npc.npcArray[i]->dy!=pNc->m_database.m_Npc.npcArray[i]->y){
						pNc->m_database.m_Npc.NpcMoveSet(i,param);
						continue;
					}else{
						pNc->m_database.m_Npc.npcArray[i]->move_F_cnt=0;
						pNc->m_database.m_Npc.npcArray[i]->rotate_F_cnt=0;
						pNc->m_database.m_Npc.npcArray[i]->status=S_STAND;
						pNc->m_database.m_Npc.npcArray[i]->mvstatus = 0;
					}
				}else{//S_STAND.. ԃ^[ɂ邱Ƃ߂鎞_...

					if(pNc->m_database.m_Npc.npcArray[i]->rotate_F_cnt > rotate_time){//ĎɓƂ
						pNc->m_database.m_Npc.npcArray[i]->ret_F_cnt+=1;//pJE^..
						if(pNc->m_database.m_Npc.npcArray[i]->ret_F_cnt>10){//10琶ꂽʒuɉ낤..
if(i==17){printf("NPC 8 _ɖ߂^C~O\n");}
							pNc->m_database.m_Npc.npcArray[i]->ret_F_cnt=0;
							pNc->m_database.m_Npc.npcArray[i]->dx = pNc->m_database.m_Npc.npcArray[i]->Gx;
							pNc->m_database.m_Npc.npcArray[i]->dy = pNc->m_database.m_Npc.npcArray[i]->Gy;
						}else{
							Rest+=1;
							if(Rest>7) Rest=0;
							switch(Rest){
								case 0:
									pNc->m_database.m_Npc.npcArray[i]->dx = pNc->m_database.m_Npc.npcArray[i]->x-5;
									pNc->m_database.m_Npc.npcArray[i]->dy = pNc->m_database.m_Npc.npcArray[i]->y;
								break;
								case 1:
									pNc->m_database.m_Npc.npcArray[i]->dx = pNc->m_database.m_Npc.npcArray[i]->x-5;
									pNc->m_database.m_Npc.npcArray[i]->dy = pNc->m_database.m_Npc.npcArray[i]->y+5;
								break;
								case 2:
									pNc->m_database.m_Npc.npcArray[i]->dx = pNc->m_database.m_Npc.npcArray[i]->x+5;
									pNc->m_database.m_Npc.npcArray[i]->dy = pNc->m_database.m_Npc.npcArray[i]->y-5;
								break;
								case 3:
									pNc->m_database.m_Npc.npcArray[i]->dx = pNc->m_database.m_Npc.npcArray[i]->x-5;
									pNc->m_database.m_Npc.npcArray[i]->dy = pNc->m_database.m_Npc.npcArray[i]->y-5;
								break;
								case 4:
									pNc->m_database.m_Npc.npcArray[i]->dx = pNc->m_database.m_Npc.npcArray[i]->x+5;
									pNc->m_database.m_Npc.npcArray[i]->dy = pNc->m_database.m_Npc.npcArray[i]->y+5;
								break;

								case 5:
									pNc->m_database.m_Npc.npcArray[i]->dx = pNc->m_database.m_Npc.npcArray[i]->x;
									pNc->m_database.m_Npc.npcArray[i]->dy = pNc->m_database.m_Npc.npcArray[i]->y-5;
								break;
								case 6:
									pNc->m_database.m_Npc.npcArray[i]->dx = pNc->m_database.m_Npc.npcArray[i]->x+5;
									pNc->m_database.m_Npc.npcArray[i]->dy = pNc->m_database.m_Npc.npcArray[i]->y;
								break;
								case 7:
									pNc->m_database.m_Npc.npcArray[i]->dx = pNc->m_database.m_Npc.npcArray[i]->x;
									pNc->m_database.m_Npc.npcArray[i]->dy = pNc->m_database.m_Npc.npcArray[i]->y+5;
								break;
							}
						}
						j=0;
						while(1){
							torf = pNc->m_database.m_Map.MapIsGo(pNc->m_database.m_Npc.npcArray[i]->dx, pNc->m_database.m_Npc.npcArray[i]->dy);//ړ\GA?
							if(torf==0){//ړ\
if(i==17) printf("%d NPCړZbeBOƂȂ@:%d,%dڕWn_:%d,%d\n",
				i,pNc->m_database.m_Npc.npcArray[i]->x, pNc->m_database.m_Npc.npcArray[i]->y,pNc->m_database.m_Npc.npcArray[i]->dx, pNc->m_database.m_Npc.npcArray[i]->dy);
								pNc->m_database.m_Npc.npcArray[i]->status=S_MOVE;
								pNc->m_database.m_Npc.npcArray[i]->mvstatus=0;
								break;
							}else{//ړs
								if(pNc->m_database.m_Npc.npcArray[i]->dx>=M_SIZE_X)
									pNc->m_database.m_Npc.npcArray[i]->dx = pNc->m_database.m_Npc.npcArray[i]->dx+5;
								else if(pNc->m_database.m_Npc.npcArray[i]->dy>=M_SIZE_X)
									pNc->m_database.m_Npc.npcArray[i]->dy = pNc->m_database.m_Npc.npcArray[i]->dy+5;
								else{
									pNc->m_database.m_Npc.npcArray[i]->dy = pNc->m_database.m_Npc.npcArray[i]->dy+5;
									pNc->m_database.m_Npc.npcArray[i]->dx = pNc->m_database.m_Npc.npcArray[i]->dx+5;
								}
if(i==17) printf("%d? NPCړsȂ̂ŖڕWn_ĂђT :%d,%dڕWn_:%d,%d\n",
				 i,pNc->m_database.m_Npc.npcArray[i]->x, pNc->m_database.m_Npc.npcArray[i]->y,pNc->m_database.m_Npc.npcArray[i]->dx, pNc->m_database.m_Npc.npcArray[i]->dy);
							}
							if(j==20){//[vh~
								pNc->m_database.m_Npc.npcArray[i]->status=S_STAND;
								break;
							}
							j++;
						}

						if(pNc->m_database.m_Npc.npcArray[i]->dx==pNc->m_database.m_Npc.npcArray[i]->x
							&&pNc->m_database.m_Npc.npcArray[i]->dy==pNc->m_database.m_Npc.npcArray[i]->y){
							pNc->m_database.m_Npc.npcArray[i]->status=S_STAND;
						}else{
							pNc->m_database.m_Npc.npcArray[i]->mvstatus=0;
							pNc->m_database.m_Npc.npcArray[i]->status=S_MOVE;
						}
						pNc->m_database.m_Npc.npcArray[i]->rotate_F_cnt = 0;
					}else pNc->m_database.m_Npc.npcArray[i]->rotate_F_cnt++;

					if(pNc->m_database.m_Npc.npcArray[i]->HP!=pNc->m_database.m_Npc.npcArray[i]->tHP){//recover
						if(pNc->m_database.m_Npc.npcArray[i]->HP>pNc->m_database.m_Npc.npcArray[i]->tHP){
							pNc->m_database.m_Npc.npcArray[i]->HP = pNc->m_database.m_Npc.npcArray[i]->tHP;
							continue;
						}else{
							pNc->m_database.m_Npc.npcArray[i]->recov_F_cnt++;
							if(pNc->m_database.m_Npc.npcArray[i]->recov_F_cnt>30){
								pNc->m_database.m_Npc.npcArray[i]->HP++;
								pNc->m_database.m_Npc.npcArray[i]->recov_F_cnt=0;
							}
						}
					}
				}
			}////U⎀񂾏Ԃł͂ȂꍇA - ̏Ԃ̐lHm\... end
		}

		LeaveCriticalSection(&pNc->m_database.m_Npc.n_cs);
		stop=GetTickCount();
		tmp= stop - start;
		if(tmp<50){
			tmp = 50-tmp;
			//printf("we Sleep %d \n",tmp);
			Sleep(tmp);
		}
	}//end for loop
}


DWORD __stdcall ThreadDataBase(PVOID param)
{//zL[ɂۑf[^ǂcaɏ.
	int que_len;
	int state,i;
	t_cir_queue * tg;
	
	cNetwork* pNc=(cNetwork*)param;
	for(;;){
		EnterCriticalSection(&pNc->m_database.d_cs);
		que_len = pNc->m_database.cirQueLen;
		if(que_len==0){
			LeaveCriticalSection(&pNc->m_database.d_cs);
			//printf("DATABASE Thread RUN OK:%d\n",GetTickCount());
			Sleep(1000);//X͌ŏCB. XsbNx..
			continue;
		}
		pNc->m_database.cirQueLen=0;
		pNc->m_database.overPos=pNc->m_database.DBcircQue[pNc->m_database.getPos].index;//I[o[t[`FbN̂߂̃CfbNX̓[vōŏɓ͂鏊..

		i=0;
		tg=&pNc->m_database.DBcircQue[pNc->m_database.getPos];
		while(i<que_len){
			i+=1;
			state = mysql_query(pNc->m_database.mydata,tg->query);
			if( state == -1 ) {
				printf("db_thread ERROR: %s\n",mysql_error(pNc->m_database.mydata));
			}
			tg = tg->next;
			pNc->m_database.getPos = tg->index;
		}//end while
		LeaveCriticalSection(&pNc->m_database.d_cs);
	}
}


DWORD __stdcall ThreadSync(PVOID param){//syncronizer thread for user's character

	long	start,stop,tmp;
	short	regenTime,Half_sec;
	int		maxNo,i,chk;
	
	cNetwork * pNc=(cNetwork*)param;

	regenTime = _ONE_SEC*30;
	Half_sec = _ONE_SEC/2;
	for(;;){
		start=GetTickCount();
		
		EnterCriticalSection(&pNc->m_cs);
		maxNo = pNc->RetrunCurrentUserNo();
		chk=0;
		//for(c=ret_session_first(maxNo);c;c=ret_session_next(maxNo))//SessArray[i].Flag=1;
		for(i=0;i<MAX_USER;i++)//SessArray[i].Flag=1;
		{
			if(chk==maxNo) break;
			if(pNc->SessArray[i].Flag==0) continue;
			if(pNc->SessArray[i].s.state==conn_state_empty||pNc->SessArray[i].s.state==conn_state_destroy){ 
				chk+=1;
				continue;
			}
			if(pNc->SessArray[i].s.userStat == S_MOVE){
				if(pNc->SessArray[i].s.Cx == pNc->SessArray[i].s.Dx
					&& pNc->SessArray[i].s.Cy==pNc->SessArray[i].s.Dy){
					printf("ڕWn_ɓĎ~܂\n");
					pNc->SessArray[i].s.userStat = S_STAND;//~܂
				}else{
					//map_chrAction_calc(pNc->SessArray[i].s);
				}
			}

			if(pNc->SessArray[i].s.attack_F_cnt>-1){
				pNc->SessArray[i].s.attack_F_cnt+=1;
				if(pNc->SessArray[i].s.attack_F_cnt>Half_sec) pNc->SessArray[i].s.attack_F_cnt=-1;
			}

			if(pNc->SessArray[i].s.party.flag==1&&pNc->SessArray[i].s.party.ison1==2){//master
				if(pNc->SessArray[i].s.party.infoFcnt>_TWO_MIN){
					pNc->SessArray[i].s.party.infoFcnt=0;
//					thr_party_info(pNc->SessArray[i].s);
				}else pNc->SessArray[i].s.party.infoFcnt++;
			}
			//pNc->dbSaveCnt++;
		}
		LeaveCriticalSection(&pNc->m_cs);

//20frame = 1000/20=  50
		stop=GetTickCount();
		tmp= stop - start;

		if(tmp<50){
			tmp = 50-tmp;
			//printf("we Sleep %d \n",tmp);
			Sleep(tmp);
		}
	}//for loop end
}


DWORD __stdcall ThreadPacketReceiver(PVOID param){

	int tcpsock=0;
	char msg[MAX_PACKET_SIZE],msgto[64][MAX_PACKET_SIZE];
	int		highest_fd;
	int		csocket,pCnt,mx;
	int		n;
	short	rPsize[64];

	unsigned short	rEnd;
	unsigned short	nEnd = PEND;
	fd_set	rfds, efds;
	int divIdx,sizee=0;

	int state;

	type_session *		   c;
	type_session *		   nc;

	cNetwork * pNc=(cNetwork*)param;
	tcpsock = pNc->m_listenSocket;
	while(TRUE)
	{
		FD_ZERO(&rfds);
		FD_ZERO(&efds);
		highest_fd = tcpsock;
		FD_SET(tcpsock,&rfds);
		for(nc=pNc->ret_session_first2(tUsercnt);nc;nc=pNc->ret_session_next2(tUsercnt)){

			csocket = nc->socket;
			FD_SET(csocket,&rfds);
			FD_SET(csocket,&efds);//extra receive

			if (csocket>highest_fd)
				highest_fd = csocket;
		}

		if (select(highest_fd+1,&rfds,NULL,&efds,(struct timeval *)0)<0)
		{
			if (errno!=EINTR)
			continue;
		}

		/* incoming	connection (if select return new conn)*/
		if (FD_ISSET(tcpsock,&rfds))
		{
			int				    asock;
			struct sockaddr_in 	caddr;
			int					caddr_len;

			/* accept the connection */
			caddr_len =	sizeof(caddr);
			if ((asock = accept(tcpsock,(struct sockaddr *)&caddr,&caddr_len))<0)
			{
	            if(errno == EINTR)
	                continue;              /* retry accept : back to while() */
	            else
					printf("error with accept\n");
				continue;
			}
		printf("USER accepted\n");
			EnterCriticalSection(&pNc->m_cs);
			if (!(c	=pNc->AllocSessArray(asock)))
			{
				printf("error with session create\n");
				LeaveCriticalSection(&pNc->m_cs);
				pNc->CloseClient(c);
				continue;
			}
			LeaveCriticalSection(&pNc->m_cs);
			tUsercnt++;
		}

		for(c=pNc->ret_session_first2(tUsercnt);c;c=pNc->ret_session_next2(tUsercnt))
		{
			if (c->state==conn_state_destroy)
			{
				tUsercnt--;
				printf("abrut disconnectss\n");
				sizee = pNc->m_database.SaveAll(c);
				pNc->CloseClient(c);
				continue;
			}

			csocket = c->socket;
			if (FD_ISSET(csocket,&rfds))
			{										//Pɓǂݎf[^ȂꍇerrnoEAGAINɃZbeBO.
				memset(msg,0,sizeof(msg));//^[l -1̂Ƃ errnoEAGAINȂcontinue
												  //łȂꍇA\Pbgڑ؂ꂽG[o肷 
				if((sizee = recv(csocket, msg, sizeof(msg), 0))<=0){//abrupt disconnect
					printf("abrut disconnect in receive\n");//0̏ꍇANCAg̃ubN
					tUsercnt--;
					sizee = pNc->m_database.SaveAll(c);
					pNc->CloseClient(c);
					continue;
				}
				memcpy(&rPsize[0],&msg[0],2);
				pCnt=0;//packet count reset
				//check packet validity
				if(rPsize[0]==sizee){
					memcpy(&rEnd,&msg[rPsize[0] -2],2);
					if(rEnd != nEnd){
						printf("pPbgG[..\n");
						continue;
					}
					pCnt+=1;
				}else if(rPsize[0]<sizee){
					divIdx=0;
					mx=0;
					for(;;){
						if(divIdx>=sizee) break;
						memset(msgto[pCnt],0,MAX_PACKET_SIZE);
						memcpy(&msgto[pCnt][0],&msg[divIdx],rPsize[pCnt]);
						memcpy(&rEnd,&msgto[pCnt][rPsize[pCnt] -2],2);
						if(rEnd != nEnd){
							printf("pPbgG[..(ĂpPbgO̒폜G[..)\n");
							break;
						}else{
							mx+=rPsize[pCnt];
							pCnt+=1;divIdx=mx;
							memcpy(&rPsize[pCnt],&msg[divIdx],2);
						}
					}
				}else continue;
				if(pCnt==1){
					memcpy(c->recvContext.Buffer,msg,sizee);
					if (c->state==conn_state_empty){
						state = pNc->BeforeAuth(msg,c,sizee);
						if(state==0){
							printf("[ULN^[[fBOs\n");
							c->state = conn_state_destroy;
							continue;
						}
					}else if(c->state==conn_state_authed){
						state = pNc->MainAct(msg,c,sizee);
						if(state==0){
							printf("[UߏG[\n");
							continue;
						}
					}else continue;
				}else{
					for(n=0;n<pCnt;n++){
						memcpy(c->recvContext.Buffer,msgto[n],rPsize[n]);
						if (c->state==conn_state_empty){
							state = pNc->BeforeAuth(msgto[n],c,rPsize[n]);
							if(state==0){
								printf("[ULN^[[fBOs\n");
								c->state = conn_state_destroy;
								continue;
							}
						}else if(c->state==conn_state_authed){
							state = pNc->MainAct(msgto[n],c,rPsize[n]);
							if(state==0){
								printf("[UߏG[\n");
								continue;
							}
						}else continue;
					}
				}
			}//if (FD_ISSET(csocket,&rfds)) end ڑ̃pPbgM

			if (FD_ISSET(csocket,&efds))
			{
				printf("abrut disconnect in efds\n");
				tUsercnt--;
				sizee = pNc->m_database.SaveAll(c);
				if(sizee==1) printf("DISCONNECT DATA SAVE OKOKOKOKOKOK\n");
				else  printf("DISCONNECT DATA SAVE FALSEFALSEFALSEFALSE\n");
				pNc->CloseClient(c);
			}//end for linked list search loop
		}
	}//end enless loop
}
