#include "map.h"
#include "network.h"
#include <assert.h>
#include <math.h>

BOOL Maps::InitMap(void){
	return TRUE;
}


void * Maps::voidListGetFirst(type_objlist const * const * * save,unsigned short i, unsigned short j)
{
	void * conn;

	if (!save)
		return NULL;
	*save = (type_objlist const * const *)&(mapArray[i][j].objL); /* avoid warning */
	if (!**save)
	{
		*save = NULL;
		return NULL;
	}
	conn = get_node_objlist(**save);
	*save = get_next_node_objlist_const(**save);
	return conn;
}


void * Maps::voidListGetNext(type_objlist const * const * * save)
{
	void * conn;

	if (!save)
	return NULL;

	if (!*save || !**save)
	{
		*save = NULL;
		return NULL;
	}
	conn = get_node_objlist(**save);
	*save = get_next_node_objlist_const(**save);
	return conn;
}


void Maps::LocateUser(Ptype_session pPerSocketCtx){//LN^[ʒuZbg

	add_node_objlist(&(mapArray[pPerSocketCtx->Ax][pPerSocketCtx->Ay].objL),pPerSocketCtx);//direct map address access
printf("[Uʒu :%d,%d\n",pPerSocketCtx->Ax,pPerSocketCtx->Ay);
}

void Maps::CharMapRemove(Ptype_session c){

	type_objlist * * pos;
	pos =  find_node_objlist(&(mapArray[c->Ax][c->Ay].objL),c);
	if(pos==NULL)
		return;
	rm_objlist(pos);
}

void Maps::MapGetSectorInfoAll(Ptype_session pPerSocketCtx,PVOID param)
{
	int i,j,x,y;
	type_objlist  const * const * tmp_objlist;
	void * tmp_char;	//
	void * ntmp_char;	//
	Ptype_session tc,usr;
	WORD objCnt=0,dLen=2,nEnd = PEND;
	char  udata[MAX_PACKET_SIZE];
	type_npc * npc;
	cNetwork* pNc=(cNetwork*)param;

	udata[dLen] = PK_OBJ_ADD;				//2
	dLen+=1;
	udata[dLen] = T_USER;//obj_type : user	//3
	dLen+=1;
	//udata[dLen] = objCnt;					//4
	dLen+=1;

	for (i=3;i>0;i--) {
		x = pPerSocketCtx->Ax -i+2;
		if(x<0 || x>S_WIDTH-1) continue;

		for(j=3;j>0;j--){
			y = pPerSocketCtx->Ay -j+2;
			if(y<0||y>S_WIDTH-1) continue;

			for(tmp_char=voidListGetFirst(&tmp_objlist,x,y); tmp_char; tmp_char=ntmp_char)
			{
				ntmp_char = voidListGetNext(&tmp_objlist);
				tc = (Ptype_session)tmp_char;
				objCnt+=1;

				memcpy(&udata[dLen],&tc->userNo,2);// cnt̕A[v
				dLen+=2;
				udata[dLen] = tc->nLen;
				dLen+=1;
				memcpy(&udata[dLen],&tc->char_name[0],tc->nLen);
				dLen+=tc->nLen;
				udata[dLen]=tc->race;
				dLen+=1;
				udata[dLen]=tc->sex;
				dLen+=1;
				udata[dLen]=tc->nation;
				dLen+=1;

				memcpy(&udata[dLen],&tc->str,2);
				dLen+=2;
				memcpy(&udata[dLen],&tc->dex,2);
				dLen+=2;
				memcpy(&udata[dLen],&tc->intel,2);
				dLen+=2;
				memcpy(&udata[dLen],&tc->hp_c,2);
				dLen+=2;
				memcpy(&udata[dLen],&tc->mana_c,2);
				dLen+=2;

				memcpy(&udata[dLen],&tc->exp,4);
				dLen+=4;
				memcpy(&udata[dLen],&tc->level,2);
				dLen+=2;
				memcpy(&udata[dLen],&tc->lvpoint,2);
				dLen+=2;
				memcpy(&udata[dLen],&tc->skexp,4);
				dLen+=4;
				udata[dLen]=tc->jobno;
				dLen+=1;
				udata[dLen]=tc->classno;
				dLen+=1;
				udata[dLen]=tc->classlevel;
				dLen+=1;

				memcpy(&udata[dLen],&tc->eq[0],2);
				dLen+=2;
				memcpy(&udata[dLen],&tc->eq[1],2);
				dLen+=2;
				memcpy(&udata[dLen],&tc->eq[2],2);
				dLen+=2;
				memcpy(&udata[dLen],&tc->eq[3],2);
				dLen+=2;
				memcpy(&udata[dLen],&tc->eq[4],2);
				dLen+=2;
				memcpy(&udata[dLen],&tc->coin,4);
				dLen+=4;

				udata[dLen]=tc->userStat;
				dLen+=1;
				if(tc->userStat==S_STAND){//stand
					udata[dLen]=tc->Dir;
					dLen+=1;
					memcpy(&udata[dLen],&tc->Ax,2);
					dLen+=2;
					memcpy(&udata[dLen],&tc->Ay,2);
					dLen+=2;
				}else if(tc->userStat==S_MOVE){//move
					udata[dLen]=tc->Dir;
					dLen+=1;
					udata[dLen]=tc->moveLevel;
					dLen+=1;
					memcpy(&udata[dLen],&tc->Cx,2);
					dLen+=2;
					memcpy(&udata[dLen],&tc->Cy,2);
					dLen+=2;
					memcpy(&udata[dLen],&tc->Dx,2);
					dLen+=2;
					memcpy(&udata[dLen],&tc->Dy,2);
					dLen+=2;
				}else if(tc->userStat==S_FIGHT){//fight
					udata[dLen]=tc->Dir;
					dLen+=1;

					udata[dLen]=tc->tgtype;//^[Qbg^Cv
					dLen+=1;
					if(tc->tgtype==0){//pk
						usr=(Ptype_session)tc->target;
						memcpy(&udata[dLen],&usr->userNo,2);
						dLen+=2;
					}else{//mon
						npc=(type_npc *)tc->target;
						memcpy(&udata[dLen],&npc->npc_id,2);
						dLen+=2;
					}

					memcpy(&udata[dLen],&tc->Ax,2);
					dLen+=2;
					memcpy(&udata[dLen],&tc->Ay,2);
					dLen+=2;
				}else{//trade
					udata[dLen]=tc->Dir;
					dLen+=1;
					memcpy(&udata[dLen],&tc->Ax,2);
					dLen+=2;
					memcpy(&udata[dLen],&tc->Ay,2);
					dLen+=2;
				}

				if(dLen>MAX_PACKET_SIZE-50){
					memcpy(&udata[dLen],&nEnd,2);
					dLen+=2;
					memcpy(&udata[0],&dLen,2);
					udata[4] = objCnt;				//4
					pNc->AllocPerSocketSndQue(pPerSocketCtx,udata,dLen);
					objCnt=0;
					dLen=5;
				}
			}
		}//inner for loop
	}//end first for loop

	if(objCnt>0){
		memcpy(&udata[dLen],&nEnd,2);
		dLen+=2;
		memcpy(&udata[0],&dLen,2);
		udata[4] = objCnt;				//4
		pNc->AllocPerSocketSndQue(pPerSocketCtx,udata,dLen);
	}
}


WORD Maps::MapIsGo(WORD x, WORD y)
{
	if(x>=M_SIZE_X || y>=M_SIZE_X) return 1;
	return map[x][y];
}


short Maps::MapReturnChrDist(WORD Ax, WORD Ay,WORD idx)
{
	int i,j,x,y;
	short dx,dy,tmp;
	type_objlist  const * const * tmp_objlist;
	void * tmp_char,* ntmp_char;
	Ptype_session c;

	for (i=3;i>0;i--) {
		x = Ax -i+2;
		if(x<0 || x>S_WIDTH-1) continue;
		for(j=3;j>0;j--){
			y = Ay -j+2;
			if(y<0||y>S_WIDTH-1) continue;
			for(tmp_char=voidListGetFirst(&tmp_objlist,x,y); tmp_char; tmp_char=ntmp_char)
			{
				ntmp_char = voidListGetNext(&tmp_objlist);
				c = (Ptype_session)tmp_char;
				if(c->userNo == idx){
					dx=c->Cx-x;
					dy=c->Cy-y;
					tmp = dx*dx+dy*dy;
					tmp = sqrt(tmp);
					return tmp;
				}
			}
		}
	}
	return -1;
}


short Maps::MapReturnDist(WORD x,WORD y,WORD xx,WORD yy )
{
	short dx,dy,tmp;

	if(x>=M_SIZE_X||xx>=M_SIZE_X||y>=M_SIZE_X||yy>=M_SIZE_X) return -1;

	dx=xx-x;
	dy=yy-y;
	tmp = dx*dx+dy*dy;
	tmp = sqrt(tmp);
	return tmp;
}


Ptype_session Maps::MapReturnActiveTarget(WORD npcx, WORD npcy,WORD sight)
{//U^X^[Ł@߂num̂ł߂numI.
	int i,j,x,y;
	type_objlist  const * const * tmp_objlist;
	void * tmp_char,* ntmp_char;
	Ptype_session c;
	WORD mapSizeX,mapSizeY,Len;

	mapSizeX=npcx/S_UNITSIZE;
	mapSizeY=npcy/S_UNITSIZE;
	for (i=3;i>0;i--) {
		x = mapSizeX -i+2;
		if(x<0 || x>S_WIDTH-1) continue;

		for(j=3;j>0;j--){
			y = mapSizeY -j+2;
			if(y<0||y>S_WIDTH-1) continue;

			for(tmp_char=voidListGetFirst(&tmp_objlist,x,y); tmp_char; tmp_char=ntmp_char)
			{
				ntmp_char = voidListGetNext(&tmp_objlist);
				c = (Ptype_session)tmp_char;
				Len = MapReturnDist(npcx, npcy, c->Cx,c->Cy);
				if(sight>=Len){
					return c;
				}
			}
		}
	}//end first for loop
	return NULL;
}


void Maps::MapSecDataSndClient(short ax, short ay,Ptype_session c,PVOID param)
{//ax,ay ZN^numf[^NCAg󂯎.
	type_objlist  const * const * tmp_objlist;
	void * tmp_char;
	void * ntmp_char;
	Ptype_session tc;
	short objCnt=0;
	char udata[MAX_PACKET_SIZE];
	WORD nEnd=PEND,dLen=2;
	Ptype_session usr;
	type_npc * npc;

	cNetwork* pNc=(cNetwork*)param;
	
	udata[dLen] = PK_OBJ_ADD;//2
	dLen+=1;
	udata[dLen] = T_USER;//obj_type : user	//3
	dLen+=1;
	//udata[dLen] = objCnt;					//4
	dLen+=1;

	for(tmp_char=voidListGetFirst(&tmp_objlist,ax,ay); tmp_char; tmp_char=ntmp_char)
	{
		ntmp_char = voidListGetNext(&tmp_objlist);
		tc=(Ptype_session)tmp_char;
		objCnt+=1;

		memcpy(&udata[dLen],&tc->userNo,2);// cnt̕A[v
		dLen+=2;
		udata[dLen] = tc->nLen;
		dLen+=1;
		memcpy(&udata[dLen],&tc->char_name[0],tc->nLen);
		dLen+=tc->nLen;
		udata[dLen]=tc->race;
		dLen+=1;
		udata[dLen]=tc->sex;
		dLen+=1;
		udata[dLen]=tc->nation;
		dLen+=1;

		memcpy(&udata[dLen],&tc->str,2);
		dLen+=2;
		memcpy(&udata[dLen],&tc->dex,2);
		dLen+=2;
		memcpy(&udata[dLen],&tc->intel,2);
		dLen+=2;
		memcpy(&udata[dLen],&tc->hp_c,2);
		dLen+=2;
		memcpy(&udata[dLen],&tc->mana_c,2);
		dLen+=2;

		memcpy(&udata[dLen],&tc->exp,4);
		dLen+=4;
		memcpy(&udata[dLen],&tc->level,2);
		dLen+=2;
		memcpy(&udata[dLen],&tc->lvpoint,2);
		dLen+=2;
		memcpy(&udata[dLen],&tc->skexp,4);
		dLen+=4;
		udata[dLen]=tc->jobno;
		dLen+=1;
		udata[dLen]=tc->classno;
		dLen+=1;
		udata[dLen]=tc->classlevel;
		dLen+=1;

		memcpy(&udata[dLen],&tc->eq[0],2);
		dLen+=2;
		memcpy(&udata[dLen],&tc->eq[1],2);
		dLen+=2;
		memcpy(&udata[dLen],&tc->eq[2],2);
		dLen+=2;
		memcpy(&udata[dLen],&tc->eq[3],2);
		dLen+=2;
		memcpy(&udata[dLen],&tc->eq[4],2);
		dLen+=2;
		memcpy(&udata[dLen],&tc->coin,4);
		dLen+=4;

		udata[dLen]=tc->userStat;
		dLen+=1;
		if(tc->userStat==0){//stand
			udata[dLen]=tc->Dir;
			dLen+=1;
			memcpy(&udata[dLen],&tc->Ax,2);
			dLen+=2;
			memcpy(&udata[dLen],&tc->Ay,2);
			dLen+=2;
		}else if(tc->userStat==1){//move
			udata[dLen]=tc->Dir;
			dLen+=1;
			udata[dLen]=tc->moveLevel;
			dLen+=1;
			memcpy(&udata[dLen],&tc->Cx,2);
			dLen+=2;
			memcpy(&udata[dLen],&tc->Cy,2);
			dLen+=2;
			memcpy(&udata[dLen],&tc->Dx,2);
			dLen+=2;
			memcpy(&udata[dLen],&tc->Dy,2);
			dLen+=2;
		}else if(tc->userStat==2){//fight
			udata[dLen]=tc->Dir;
			dLen+=1;
			udata[dLen]=tc->tgtype;//^[Qbg^Cv
			dLen+=1;
			if(tc->tgtype==0){//pk
				usr=(Ptype_session)tc->target;
				memcpy(&udata[dLen],&usr->userNo,2);
				dLen+=2;
			}else{//mon
				npc=(type_npc *)tc->target;
				memcpy(&udata[dLen],&npc->npc_id,2);
				dLen+=2;
			}
			memcpy(&udata[dLen],&tc->Ax,2);
			dLen+=2;
			memcpy(&udata[dLen],&tc->Ay,2);
			dLen+=2;
		}else{//trade,die
			udata[dLen]=tc->Dir;
			dLen+=1;
			memcpy(&udata[dLen],&tc->Ax,2);
			dLen+=2;
			memcpy(&udata[dLen],&tc->Ay,2);
			dLen+=2;
		}

		if(dLen>MAX_PACKET_SIZE-40){
			memcpy(&udata[dLen],&nEnd,2);
			dLen+=2;
			memcpy(&udata[0],&dLen,2);
			udata[4] = objCnt;				//4
			pNc->AllocPerSocketSndQue(c,udata,dLen);
			objCnt=0;
			dLen=5;
		}
	}//end for loop

	if(objCnt>0){
		memcpy(&udata[dLen],&nEnd,2);
		dLen+=2;
		memcpy(&udata[0],&dLen,2);
		udata[4] = objCnt;				//4
		pNc->AllocPerSocketSndQue(c,udata,dLen);
	}
}


void Maps::MapSecDataSnd(short ax, short ay, char *retdata,short dLen,PVOID param){//ax,ay ZN^numretdata𑗂.

	type_objlist  const * const * tmp_objlist;
	void * tmp_char;
	void * ntmp_char;
	Ptype_session tc;
	
	cNetwork* pNc=(cNetwork*)param;

	for(tmp_char=voidListGetFirst(&tmp_objlist,ax,ay); tmp_char; tmp_char=ntmp_char)
	{
		ntmp_char = voidListGetNext(&tmp_objlist);
		tc = (Ptype_session)tmp_char;
		pNc->AllocPerSocketSndQue(tc,retdata,dLen);
	}
}
