#pragma once
#include "define.h"
#ifndef OBJECTLIST_DEFINE
#include "ObjectList.h"
#endif

class Maps:public ObjectList
{

public:
	Maps(void){
		int i,j;
		for(i=0;i<S_WIDTH;i++)
			for(j=0;j<S_WIDTH;j++)
				mapArray[i][j].objL=NULL;
	}

	~Maps(void){}

	void LocateUser(Ptype_session c);
	void * voidListGetFirst(type_objlist const * const * * save,unsigned short i, unsigned short j);
	void * voidListGetNext(type_objlist const * const * * save);

private:
	BOOL InitMap(void);

public:
	type_npcmap		mapArray[S_WIDTH][S_WIDTH];
	char			map[M_SIZE_X][M_SIZE_X];

	void MapGetSectorInfoAll(Ptype_session c,PVOID param);
	WORD MapIsGo(WORD x, WORD y);
	short MapReturnChrDist(WORD Ax, WORD Ay,WORD idx);
	short MapReturnDist(WORD x,WORD y,WORD xx,WORD yy );
	Ptype_session MapReturnActiveTarget(WORD npcx, WORD npcy,WORD sight);
	void MapSecDataSndClient(short ax, short ay,Ptype_session c,PVOID param);
	void MapSecDataSnd(short ax, short ay, char *retdata,short dLen,PVOID param);
	void CharMapRemove(Ptype_session c);

};
