#pragma once
#include "publicInc.h"
typedef enum
{
    conn_state_empty,	//not authed
    conn_state_authed,	//lobby status
    conn_state_game,		//status game
    conn_state_destroy	//status exited
} type_conn_state;

typedef struct partySystem
{
	BYTE			flag;		//p[eBQ̉
	BYTE			cnt;		//p[eBl

	WORD			memidx;		//̈ʒu..
	WORD			infoFcnt;	//[Um点JEg..
	void			*waitfor;	//ҋ@num[Uԍ
	void			*master;
	WORD			ison1;		//0:NULL 	1:linked		2:myself(member#==NULL)
	void			*mem2;
	WORD			ison2;
	void			*mem3;
	WORD			ison3;
}type_party;



typedef struct tradeSystem
{
	WORD			flag;			//g[h
	void			*tg;
	WORD			confirm;

	BYTE			itemidx[2];		//g[hCxg[ەۑl̓Cxg[CfbNX
	WORD			invidx[2];		//ACeCfbNX
	WORD			cnt[2];			//ACeJEg
	DWORD			coin;
}type_trade;



typedef struct tagIo
{
	int				len;
	char			Buffer[MAX_BUFFER];
	BOOL			flag;
	DWORD			queIndex;			//SndQueArraỹCfbNX

} PerIo, *PPerIo;

typedef struct tagSocket
{
	SOCKET				socket;				//socket No.
	PerIo				recvContext;
	DWORD				sessIndex;			//tagSessionArraỹCfbNX
	
	/*̓[U*/
	char			  	userid[32];
	char			  	char_name[32];
	WORD			  	uLen;
	WORD				nLen;
	WORD  				userNo;

	type_conn_state 	state;
	DWORD    			sessionkey;
	DWORD 				clientver;
	DWORD				disco;

	BYTE				dbLoaded;	//db loadL
	BYTE				userStat;	//[Ȕ 0:stand 1:move 2:fight 3:trade
	short				frameCnt;	//t[JE^

	/****LN^[֘A****/
	WORD				Cx;			//current loc x ݒn
	WORD				Cy;			//current loc y
	WORD				Dx;			//destination x
	WORD				Dy;			//destination y

	WORD				Ax;			//current sector X
	WORD				Ay;			//current sector y
	WORD				Bx;			//before  sector X
	WORD				By;			//before  sector y

	BYTE				race;
	BYTE				sex;
	BYTE				nation;

	DWORD				str;		//
	DWORD				dex;		//q
	DWORD				intel;	//m

	DWORD				attack;	//U
	DWORD				defence;	//h

	DWORD				hp_m;
	WORD				hp_c;
	WORD				mana_m;//@XLU..
	WORD				mana_c;

	DWORD				exp;
	WORD				level;
	WORD				lvpoint;
	DWORD				skexp;

	BYTE				jobno;
	BYTE				classno;
	BYTE				classlevel;

	WORD				worldmap;	//map index
	WORD				moveLevel; 	//LN^[̓x...
	BYTE				Dir;		//direction of destination(tile no.)

	/***** targetting ********/
	BYTE				tgtype;
	WORD				target_id;
	void				*target;

	/**** item definition****/
	WORD				eq[7];//z

	/**** inventory definition****/
	WORD				inven[4];//Cxg[4
	BYTE				inven_cnt[4];//Cxg[48

	/**** warehouse definition****/
	WORD				ware[8];//q8
	BYTE				ware_cnt[8];//q8

	/**** skill definition.****/
	WORD				skill[4];
	BYTE				skill_lv[4];

	DWORD 				coin; //

	char				move_F_cnt;
	WORD				mana_F_cnt;// i}񕜗pJE^..
	WORD				recov_F_cnt;// q[[񕜗pJE^..
	short				attack_F_cnt;// q[[UxpJE^..
	short				regen_F_cnt;
	DWORD				dbSaveCnt;

	BYTE				pkmode;
	type_party			party;
	type_trade			trade;

} type_session, *Ptype_session;


typedef struct tagSockQueue	//f[^Mpm[h 
{
	SOCKET	socket;				
	DWORD	sessIndex;			
	PPerIo  sendContext;

} PerSocketQue, *PPerSocketQue;


typedef struct tagSessionArray
{
	BYTE Flag;
	DWORD sessIndex;
	type_session s;

} SessionArray;

typedef struct tagQueArray
{
	BYTE Flag;
	DWORD queIndex;
	PPerSocketQue pPerSocketCtx;

} QueArray;



/*obj list*/

typedef struct objlist
{
    struct objlist  *	next;
    void			*	data;
} type_objlist,*ptype_objlist,**pptype_objlist;




/* item ֘A */
typedef struct itemArray
{
	BYTE		tTile;//ʒu\GA? \:0, s\:1
	BYTE		exFlag;//łɂ̂?		: 0, Ȃ:1
}type_itemArr;


typedef struct itemsector
{
	type_objlist *	objL;
}
type_itemSect;


typedef struct fItem
{
	WORD		idx;//T[oŐCfbNX
	WORD 		x;
	WORD		y;

	WORD		item_idx;
	WORD		item_idx_cnt;//JEg

	WORD		rmFcnt;
	WORD		rmHcnt;
}
type_itemLst_field;


typedef struct item_idx
{
	WORD 					flag;//0Ȃ󂫃CfbNX
	type_itemLst_field	*	item;
}
type_itemIdx;


typedef struct item
{
	char		is_init;
	char		idx_type;		//CfbNX^Cv

	WORD		item_no;		//ACeԍ̓ACez̃CfbNX (ACeŗLԍ)..
	short		req;			//vx
	char		equip;			//ʒu 0: 1:Ў(E) 2: 3: 4: 5:lbNX 6:w
	char		item_type;		//^Cv
	WORD		pwr;			//U͂܂͖h
	char		range;			//Ō
	char		itemclass;		//gpn0: 1:Z 2:̑
	WORD		amount;			//{
	WORD		coin;			//i
	char		isbuy;			//w\̉
}type_item;




/* npc֘A */

typedef struct npc_baseinfo
{
	char		div;		//1:npc, 2:monster
	char		gtype;	//
	WORD		npc_id; //hc(ŗLԍ)

	WORD		x;
	WORD		y;
	WORD		dx;
	WORD		dy;
	WORD		speed;

	char		DirLoc;
	WORD		ARx;//array index
	WORD		ARy;
	WORD		BSx;			//ȑÕZN^
	WORD		BSy;			//ȑÕZN^

	WORD		Gx;			//gen
	WORD		Gy;			//gen

	short		level;

	short		tHP;
	short		HP;
	WORD		AP;
	WORD		DP;

	WORD		EXP;

	char		bat_type;//퓬^CvUAU,+A
	char		sk_stat;//npc̏

	WORD		status;//npc..
	WORD		mvstatus;//npc

	WORD		targetNO;
	void		*targetChr;
	char		tgFlag;		//0: flag off 1: ^[QbgǐՒ

	WORD		Sight;	//..
	WORD		tgLen;	//˒.

	WORD		recov_F_cnt;//񕜗pJE^..
	WORD		move_F_cnt;//JE^..
	WORD		heat_F_cnt;//ŌpJE^..
	WORD		active_F_cnt;//UpJE^..
	WORD		rotate_F_cnt;//pJE^..
	WORD		ret_F_cnt;//߂JE^..
	WORD		wait_F_cnt;//҂JE^..
	WORD		regen_F_cnt;//[WFJE^..
}
type_npc;



typedef struct npcmapsys
{
	type_objlist *	objL;
}
type_npcmap;



typedef struct npc_default
{
	WORD no;
	WORD gtype;
	WORD level;
	WORD speed;

	WORD item[12];
	WORD rate[12];
} type_gnpc;


/* db֘A */

typedef struct cqueues{

	struct cqueues * 	next;
	DWORD				index;
	char				query[1024];

}t_cir_queue;
