#pragma once
#include "define.h"
#ifndef OBJECTLIST_DEFINE
#include "ObjectList.h"
#endif

class Npcs
{

public:
	Npcs(void){
		int i,j;
		for(i=0;i<S_WIDTH;i++)
			for(j=0;j<S_WIDTH;j++)
				mapNpcArray[i][j].objL=NULL;		
		InitializeCriticalSection(&n_cs);
		npc=mon=npc_cnt=0;


		InitNpc();
	}
	~Npcs(void){}
	
	void   InitNpc(void);
	void   NpcSetDef(char div, short no, char gtype, char level, char speed, short * item, char * rate);
	void   NpcDataSet(char div,short no,short x,short y);//char gtype, char level, char speed,
	void * voidNpcListGetFirst(type_objlist const * const * * save,unsigned short i, unsigned short j);
	void * voidNpcListGetNext(type_objlist const * const * * save);
	void   Npc3x3SecterInfo(Ptype_session c,PVOID param);
	int	   NpcReturnDist(WORD x, WORD y, WORD idx);
	BOOL   NpcChrAttackNpc(Ptype_session c,WORD Index,PVOID param);
	BOOL   NpcDropItem(type_npc * npc, WORD userNo,PVOID param);
	void   NpcSkill1(Ptype_session c, PVOID param, WORD pwr, WORD xx, WORD yy, char * gDat);
	void   NpcRegen(WORD idx,PVOID param);
	void   NpcAttackChr(Ptype_session chr, WORD idx,PVOID param);
	type_npc * NpcReturnFight(WORD idx,PVOID param);
	void   NpcMoveSet(WORD idx,PVOID param);
	void   NpcMoveAddInfo(type_npc * npc,PVOID param);
	BOOL   NpcMoveOne(type_npc * npc,PVOID param);
	void   NpcMapInit(type_npc * npc);

public:
	type_npc 	   *npcArray[_MAX_MONSTER_NO];//X^[̐(ꂽ npcXg) z񏉊Kv!!
	type_npcmap		mapNpcArray[S_WIDTH][S_WIDTH];
	type_gnpc 		def_mon[21];//X^[ 񃊃Xg
	type_gnpc 		def_npc[1];//NPC񃊃Xg
	DWORD			npc_cnt;
	WORD			mon,npc;
	CRITICAL_SECTION	n_cs;

private:
	ObjectList			m_obj;
};
