#include "skill.h"
#include "network.h"
#include <assert.h>

void Skills::DefSkill(WORD type,WORD skillidx,char * lvpwr, char * lvupcost,DWORD getcoin){
	
	int i;

	if(skillidx>3) return;
	skill_def[skillidx].type=type;
	skill_def[skillidx].skillidx=skillidx;
	skill_def[skillidx].getcoin=getcoin;

	for(i=1;i<11;i++){
		if(i==1) skill_def[skillidx].lvpwr[i]=atoi(strtok(lvpwr,"|"));
		else skill_def[skillidx].lvpwr[i]= atoi(strtok(NULL,"|"));
	}
	for(i=1;i<11;i++){
		if(i==1) skill_def[skillidx].lvupcost[i]=atoi(strtok(lvupcost,"|"));
		else skill_def[skillidx].lvupcost[i]= atoi(strtok(NULL,"|"));
	}
}



void Skills::SkillGet(Ptype_session c,PVOID param)
{//XL폜ǉ...
	BYTE skidx;
	int i,res=0,invidx=0,chk=0;
	WORD nEnd = PEND,Len=2;
	char msg[32];

	cNetwork* pNc=(cNetwork*)param;

	skidx = c->recvContext.Buffer[3];
	if(skidx>3) res=1;//skill check
	else if(skill_def[skidx].getcoin>c->coin) res=2;
	for(i=0;i<4;i++){
		if(c->skill[i]==0&&chk==0){
			invidx=i;
			chk=1;
		}
		if(c->skill[i]==skidx){
			res=3;
			break;
		}
	}

	if(res==0&&chk==1){
		EnterCriticalSection(&pNc->m_cs);
		c->skill[invidx]=skidx;
		c->skill_lv[invidx]=1;
		c->coin-=skill_def[skidx].getcoin>c->coin;
		LeaveCriticalSection(&pNc->m_cs);
	}else res=4;

	msg[Len]=PK_SKILL_GET;
	Len+=1;
	msg[Len]=res;
	Len+=1;
	msg[Len]=invidx;
	Len+=1;
	memcpy(&msg[Len],&nEnd,2);
	Len+=2;
	memcpy(&msg[0],&Len,2);
	pNc->AllocPerSocketSndQue(c,msg,Len);
}


void Skills::SkillLevelUp(Ptype_session c,PVOID param)
{
	BYTE invidx,skidx=0,lv;
	int res=0;
	char  msg[32];
	WORD Len=2,nEnd = PEND;

	cNetwork* pNc=(cNetwork*)param;
	
	invidx = c->recvContext.Buffer[3];
	if((skidx=c->skill[invidx])==0) res=2;
	else if((lv=c->skill_lv[invidx])>=10) res=3;
	else if(skill_def[skidx].lvupcost[lv]>c->coin) res=4;
	else{
		EnterCriticalSection(&pNc->m_cs);
		c->coin-=skill_def[skidx].lvupcost[lv]>c->coin;
		c->skill_lv[invidx]+=1;
		LeaveCriticalSection(&pNc->m_cs);
	}

	msg[Len]=PK_SKILL_LVUP;
	Len+=1;
	msg[Len]=res;
	Len+=1;
	msg[Len]=skidx;
	Len+=1;
	msg[Len]=invidx;
	Len+=1;
	msg[Len]=c->skill_lv[invidx];
	Len+=1;
	memcpy(&msg[Len],&nEnd,2);
	Len+=2;
	memcpy(&msg[0],&Len,2);
	pNc->AllocPerSocketSndQue(c,msg,Len);
}


void Skills::SkillUse(Ptype_session c,PVOID param)
{//npĉݎ pk͕ʓr...Ă݂..
	WORD x,y,Len=2,nEnd = PEND;
	BYTE invidx,res=0,NPCcnt=0,USRcnt=0,tot=0;
	char NPCDat[512],USRDat[512],msg[1024];
	short lv;
	
	cNetwork* pNc=(cNetwork*)param;

	invidx=c->recvContext.Buffer[3];
	if(invidx==0||invidx>3) return;
	if(c->mana_c<10) return;
	else{
		EnterCriticalSection(&pNc->m_cs);
		c->mana_c-=10;
		LeaveCriticalSection(&pNc->m_cs);
	}

	msg[Len]=PK_SKILL_USE;
	Len+=1;
	msg[Len]=res;
	Len+=1;
	msg[Len]=T_USER;
	Len+=1;
	memcpy(&msg[Len],&c->userNo,2);
	Len+=2;

	switch(c->skill[invidx]){
		case 1://area att PԃXL

			memcpy(&x,&c->recvContext.Buffer[4],2);
			memcpy(&y,&c->recvContext.Buffer[6],2);

			msg[Len]=1;
			Len+=1;
			memcpy(&msg[Len],&x,2);
			Len+=2;
			memcpy(&msg[Len],&y,2);
			Len+=2;
			Len+=1;//obj 
			if(c->pkmode==1){//pk on

			}else{//pk off
				lv=c->skill_lv[invidx];
				pNc->m_database.m_Npc.NpcSkill1(c,param,skill_def[1].lvpwr[lv], x, y, NPCDat);
				NPCcnt=NPCDat[0];
			}
			if(NPCcnt>0){
				tot+=NPCcnt;
				memcpy(&msg[Len],&NPCDat[1],NPCcnt*5);
				Len+=NPCcnt*5;
			}
			if(USRcnt>0){
				tot+=USRcnt;
				memcpy(&msg[Len],&USRDat[1],USRcnt*5);
				Len+=USRcnt*5;
			}
		break;
		case 2://QԃXL
			if(c->pkmode==1){//pk on
			}else{//pk off

			}
		break;
		case 3://RԃXL
			if(c->pkmode==1){//pk on
			}else{//pk off

			}
		break;
	}
	msg[12]=tot;
	memcpy(&msg[Len],&nEnd,2);
	Len+=2;
	memcpy(&msg[0],&Len,2);
	pNc->AllocPerSocketSndQueSectorAll(c->Ax,c->Ay,msg,Len,NULL);
}
